;Test our nice new fontimages.
	; / How to load and use them!

Graphics 640,480,32,2
SetBuffer BackBuffer()

Type font
	Field width[128]
	Field img
	Field wide
	Field high
End Type


My1.Font=LoadImgFont("c64_16")
My2.Font=LoadImgFont("Visitor_24_3D")
My3.Font=LoadImgFont("Visitor_24_Striped")
My4.Font=LoadImgFont("c64_32_Striped")

Repeat
Cls
	y=0
	y=y+24:ImgFont my1.font,2,y,"This is a test"
	y=y+24:ImgFont my1.font,2,y,"0123 ABC abc"
	y=y+24:ImgFont my2.font,2,y,"The Quick Brown Fox Jumps Over the Lazy Dog."
	y=y+24:ImgFont my2.font,2,y,"Socoder.Net"
	y=y+24:ImgFont my3.font,2,y,"Kickass fonts!"
	y=y+24:ImgFont my3.font,2,y,"Easily Made! (Although this one's a bit hard to see!)"	
	y=y+24:imgfont my4.font,2,y,"FPS : "+fps
	y=y+38:imgfont my4.font,2,y,"Yeay!"	
	
	y=y+38:ImgFont my1.font,2,y,"Now, if you want to distribute these fonts, you no longer"
	y=y+18:ImgFont my1.font,2,y,"need the .ttf originals.  You only need the single .fnt file,"
	y=y+18:ImgFont my1.font,2,y,"which holds both the font image, and the data used for"	
	y=y+18:ImgFont my1.font,2,y,"the font's widths and heights."	
	
	
	fps=1000/(MilliSecs()-lastframe)
	lastframe=MilliSecs()
Flip
Until KeyDown(1)

End

; Loader....

Function LoadImgFont.font(in$)
	ThisFont.Font=New font
	quicky=ReadFile(in$+".fnt")
	
	ThisFont\wide=ReadByte(quicky)
	ThisFont\high=ReadByte(quicky)
	
	ThisFont\img=CreateImage(ThisFont\wide,ThisFont\high,96):MaskImage ThisFont\img,255,0,255
	For n=32 To 127
		ThisFont\width[n]=ReadByte(quicky)
		
		LockBuffer(ImageBuffer(ThisFont\img,n-32))
		For y=0 To ThisFont\high-1
			For x=0 To ThisFont\wide-1

				r=ReadByte(quicky)
				g=ReadByte(quicky)
				b=ReadByte(quicky)
				a=ReadByte(quicky)
				
				c=(r Shl 16)+(g Shl 8)+b
				WritePixelFast(x,y,c, ImageBuffer(ThisFont\img,n-32) )
				
			Next
		Next
		UnlockBuffer(ImageBuffer(ThisFont\img,n-32))
	Next
	
	CloseFile quicky
	
	Return ThisFont.font
	
End Function



; Drawer...

Function imgfont(ThisFont.font,x,y,st$)
	For n=1 To Len(st$)
		DrawImage ThisFont\img,x,y,Abs((Asc(Mid$(st$,n,1)) Mod 128)-32)
		x=x+ThisFont\width[Asc(Mid$(st$,n,1))]
	Next
End Function