Graphics 640,480,32,2
SetBuffer BackBuffer()


Global y
Global grabwide,grabhigh
Global gap=1		;Default gap between chrs
Global fontimg

Dim width(256)


;Makefont usage.
;	Makefont( 	Fontname$,			Name of the font
;				[FontSize],			Size of the font. Defaults to 12
;				[DrawStyle],		Style, as designed in the DrawChr function below.  Defaults to 1
;				[Gap],				Gap between chrs. Defaults to 1
;				[Save FileName$]	Filename to save as. (with .fnt added on the end!)
;			)

;MakeFont("blitz",8)	; This seems to be breaking on my PC!  Not sure why!


MakeFont("commodore 64.ttf",16,1,1,"c64_16")
MakeFont("visitor tt2 brk.ttf",24,2,1,"Visitor_24_3D")
MakeFont("visitor tt2 brk.ttf",24,3,1,"Visitor_24_Striped")
MakeFont("commodore 64.ttf",32,3,1,"c64_32_Striped")




Function DrawChr(x,y,Ch,style)	; Different draw styles.
Select style
	Case 1	; Plain Text
	
		Color 255,255,255
		Text x,y,Chr$(ch)
	
	
	Case 2	; Slightly 3D-ish
	
		For ang=0 To 360 Step 10
			Color 180+Sin(ang)*70,180+Sin(ang)*70,180+Sin(ang)*70
			Text 101+Sin(ang)*1,1-Cos(ang)*1,Chr$(Ch)
		Next
		Color 180,180,180
		Text 101,1,Chr$(Ch)
	
	Case 3	; Stripey
		Color 255,255,255
		Text 101,1,Chr$(ch)
		w=StringWidth(Chr$(ch))
		h=FontHeight()
		LockBuffer BackBuffer()
			For x=101 To 101+w
					d#=1000.0/Float(h)
					s#=1000
					r#=250:g#=0:b#=0
					
				For y=1 To 1+h			
					in=ReadPixelFast( x,y, BackBuffer() ):out=in
					
						s=s-d
						If s>650 And s<900 Then r=r-d:g=g+d
						If s<650 And s>400 Then g=g-d:b=b+d
						If s<400 Then r=r+d:b=b-d
						If r<0 Then r=0
						If r>250 Then r=250
						If g<0 Then g=0
						If g>250 Then g=250
						If b<0 Then b=0
						If b>250 Then b=250
					
					If (in And $FFFFFF)=$FFFFFF		
						out=(255 Shl 24) + (r Shl 16) + (g Shl 8) + b
						WritePixelFast(x,y,out)
					EndIf
				Next
			Next
		UnlockBuffer BackBuffer()
				
		; Feel free to add your own.

End Select
End Function






Function MakeFont(FntName$,fnthigh=12,style=1,gap=1,savename$="")
	If savename$=""
		savename$=fntname$+"_"+fnthigh
		savename$=Replace$(savename$," ","_")
		savename$=Replace$(savename$,".ttf","")
		savename$=Replace$(savename$,".fon","")	
	EndIf
	
	tfont=LoadFont(fntname$,fnthigh)
	SetFont tfont


	
wide=1
high=FontHeight()

For n=32 To 127
	If StringWidth(Chr$(n))>wide Then wide=StringWidth(Chr$(n))
Next

grabwide=Ceil(Float(wide)/8)
grabwide=grabwide*8
grabhigh=grabwide

If high>wide
	grabhigh=Ceil(Float(high)/8)
	grabhigh=grabhigh*8
	grabwide=grabhigh
EndIf

	; ^ I made sure the font tiles are multiples of 8...  That's important when you're trying to load images as textures!

fontImg=CreateImage(grabwide,grabhigh,96):MaskImage fontimg,255,0,255

bang=CreateImage(grabwide,grabhigh):MaskImage bang,255,0,255


ClsColor 255,0,255
Cls

For n=32 To 127
	
	Cls
	
	DrawChr(100,0,n,style)
	
	CopyRect 100,0,grabwide,grabhigh,0,0,BackBuffer(),ImageBuffer(fontimg,n-32)
	
	hitr=0
	hitl=-1
	
	For atx=-1 To grabwide
		If ImagesCollide(fontImg,0,0,n-32,bang,atx-grabwide,0,0)=0 And atx>hitl Then hitl=atx
	Next
	
	For atx=grabwide To 0 Step -1
		If ImagesCollide(fontImg,0-(hitl),0,n-32,bang,atx,0,0) And atx>hitr Then hitr=atx
	Next
	
	If n=32 Then hitr=grabwide*0.2:hitl=0
	width(n)=hitr+gap+1
	
	CopyRect 100+hitl,0,grabwide,grabhigh,0,0,BackBuffer(),ImageBuffer(fontimg,n-32)
	
	If n Mod 10=1 Then Flip False
Next


ClsColor 0,0,0
Color 255,0,0

Cls
y=0




compare "This is a test"
compare "0123 ABC abc"
compare "The Quick Brown Fox Jumps Over the Lazy Dog."
compare "Socoder.Net"
compare "SoC - Coming soon! ..."

compare "Please wait - Saving Font"



Flip

	
	
	SaveFont(savename$)
	FreeImage fontimg
	FreeImage bang
	FreeFont tfont
End Function





End


;May as well leave the rest as it is!

.MakeFont


Function Compare(txt$)
ImgFont 2,y,txt$ : y=y+grabhigh:Text 2,y,txt$:y=y+grabhigh*1.4
End Function



Function SaveFont(in$)
	quicky=WriteFile(in$+".fnt")
	
	WriteByte(quicky,grabwide)
	WriteByte(quicky,grabhigh)
	For n=32 To 127
		WriteByte(quicky,width(n))
		LockBuffer(ImageBuffer(fontimg,n-32))
		For y=0 To grabhigh-1
			For x=0 To grabwide-1
				c=ReadPixelFast(x,y,ImageBuffer(fontimg,n-32))
				r=(c And $FF0000) Shr 16
				g=(c And $00FF00) Shr 8
				b=(c And $0000FF)
				a=255:If r=255 And g=0 And b=255 Then a=0
				WriteByte(quicky,r)
				WriteByte(quicky,g)
				WriteByte(quicky,b)
				WriteByte(quicky,a)
			Next
		Next
		UnlockBuffer(ImageBuffer(fontimg,n-32))
		DebugLog n
	Next
	
	CloseFile quicky
	
End Function




; Use Imgfont

Function imgfont(x,y,st$)
For n=1 To Len(st$)
If Asc(Mid$(st$,n,1))>31 And Asc(Mid$(st$,n,1))<128 Then DrawImage fontimg,x,y,Asc(Mid$(st$,n,1))-32
x=x+width(Asc(Mid$(st$,n,1)))
Next
End Function